package figuras;


import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;

public class Circulo extends FiguraPadre {
	
	
	private Point puntoCentro= new Point();
	private int radio;
	private int alto, ancho;
	
	

	public void setFin(Point fin) {
		this.fin = fin;
		calcularRadio();
	}

	public Circulo(Point comienzo, Point fin) {
		super();
		this.comienzo = comienzo;
		this.fin = fin;
		calcularRadio();
	}

	public int getRadio() {
		return radio;
	}

	public void dibujarFigura(Graphics g) {
		g.setColor(color);
		Graphics2D g2 = (Graphics2D) g;
		g.drawOval(puntoCentro.x, puntoCentro.y, radio, radio);
		//g2.drawOval(comienzo.x, comienzo.y, radio, radio);
		// g.drawOval(comienzo.x, comienzo.y, radio, radio);
		// g.fillRect(getComienzo().x, getComienzo().y, radio,radio );
	}

	private void calcularRadio() {
		//System.out.println(comienzo.y-fin.y);
		 puntoCentro.y=(3*comienzo.y-fin.y+5)/2;
		 puntoCentro.x=(3*comienzo.x-fin.x+5)/2;
		 ancho=(fin.x-comienzo.x);
		 alto=(fin.y-comienzo.y);
		 radio = (int) Math.hypot((comienzo.x - fin.x), (comienzo.y - fin.y));
	}



	public FiguraPadre crear(Point comienzo, Point fin) {
		return new Circulo(comienzo, fin);
	}

	public boolean busqueda(int x, int y) {
		
		int valor =(int) Math.hypot(Math.abs(puntoCentro.x - x), Math.abs(puntoCentro.y - y));
		if (Math.abs((radio-valor  )) < delta) {
			return true;
		} else {
			return false;
		}
	}
	public boolean muyPequeo(){

		if(((radio)<delta)){
			return true;
		}
		return false;
	}
	public void actualizarPos(Point punto){
		puntoCentro.x=punto.x;
		puntoCentro.y=punto.y;	
	}
}
