package figuras;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;

public class Cuadrado extends FiguraPadre {

	private int alt;
	private int ancho;

	public void setFin(Point fin) {
		this.fin = fin;
		calcularAltoAncho();
	}

	public Cuadrado(Point comienzo, Point fin) {
		super();
		this.comienzo = comienzo;
		this.fin = fin;
		calcularAltoAncho();
	}

	public int getAlt() {
		return alt;
	}

	public int getAncho() {
		return ancho;
	}

	public void dibujarFigura(Graphics g) {
		g.setColor(color);
		g.drawRect(getComienzo().x, getComienzo().y, getAncho(), getAlt());
	}

	private void calcularAltoAncho() {
		this.alt = this.fin.y - this.comienzo.y;
		this.ancho = this.fin.x - this.comienzo.x;
	}



	public FiguraPadre crear(Point comienzo, Point fin) {
		return new Cuadrado(comienzo, fin);
	}

	public boolean busqueda(int x, int y) {
		boolean lH = false; // lado Horizonal
		boolean lV = false; // lado Vertical
		if (((comienzo.x - delta) < x) && ((comienzo.x + delta + ancho) > x)) {
			lH = true;
		}
		if (((comienzo.y - delta) < y) && ((comienzo.y + delta + alt) > y)) {
			lV = true;
		}
		return ((lH) && (lV));
	}
	public boolean muyPequeo(){
		if(((fin.x-comienzo.x)<delta)||((fin.y-comienzo.y)<delta)){
			return true;
		}
		return false;
	}
	public void actualizarPos(Point punto){
		comienzo=punto;	
	}
}
