package visual;

import java.awt.Color;

import oyentes.OyenteBotonesAcciones;
import oyentes.OyenteBotonesFiguras;
import oyentes.OyentesCargarFigura;
import oyentes.OyentesDibujar;
import oyentes.OyentesMover;

import java.awt.BorderLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import lienzo.Lienzo;
import lienzo.JPanPersonal;
import javax.swing.JFrame;
import javax.swing.JToolBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JButton;
import javax.swing.JPanel;

import opcionesFiguras.OpcionesFiguras;

import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.event.KeyEvent;
import java.awt.Rectangle;
import javax.swing.JTextField;
import javax.swing.JMenuBar;

import acciones.AccionesPermitidas;

import figuras.FiguraPadre;

import java.awt.GridLayout;
import java.util.ArrayList;

public class Principal extends JFrame {

	private static final long serialVersionUID = 1L;
	private String accPlan; //accion planteada
	private JPanel jContentPane = null;
	private JPanel opcionesDibujo = null;
	private OpcionesFiguras figuras = new OpcionesFiguras();
	private MouseMotionAdapter oyentesDibujarMovimiento;  //  @jve:decl-index=0:
	private MouseMotionAdapter oyentesMoverMovimiento;  //  @jve:decl-index=0:
	private String nombreUltimaFigura = "Cuadrado";
	private OyentesDibujar oyentesDibujar;
	private OyentesMover oyentesMover;
	private JTextField jTextField = null;
	private JPanPersonal jPanel = null;
	private JButton botonEscritura = null;
	private JButton botonCuadrado = null;
	private JButton botonCirculo = null;
	private JMenuBar menuPrincipal = null;
	private JMenu inicio = null;
	private JMenu edicion = null;
	private JMenu opciones = null;
	private JMenu ayuda = null;
	private JToolBar opcionesFiguras = null;
	private JToolBar OpcionesMouse = null;
	private JMenuItem acercaD = null;
	private JMenuItem guardar = null;
	private JMenuItem guardarComo = null;
	private JMenuItem abrir = null;
	private JMenuItem salir = null;
	private JMenuItem copiar = null;
	private JMenuItem pegar = null;
	private JPanel cantidadHojas = null;
	private JPanel propiedadesFiguras = null;
	private JPanel panelOpciones = null;
	private JButton botonCrear = null;
	private JButton botonMover = null;
	private JButton botonModificar = null;
	private MouseAdapter oyeBotFig;
	private MouseAdapter oyeBotAcc;
	private AccionesPermitidas AccAct= new AccionesPermitidas();  //  @jve:decl-index=0:
	private JButton botonPdf = null;
	private JButton botonImagen = null;
	public Principal() {
		super();
		initialize();
	}

	private void initialize() {

		this.setSize(698, 310);
		this.setJMenuBar(getMenuPrincipal());
		this.setContentPane(getJContentPane());
		this.setTitle("Creador PDF");

	}

	/**
	 * This method initializes opcionesDibujo
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getOpcionesDibujo() {
		if (opcionesDibujo == null) {
			opcionesDibujo = new JPanel();
			opcionesDibujo.setLayout(new GridBagLayout());
			opcionesDibujo.add(getBotonPdf(), new GridBagConstraints());
		}
		return opcionesDibujo;
	}

	/**
	 * This method initializes botonCuadrado
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBotonCuadrado() {
		if (botonCuadrado == null) {
			botonCuadrado = new JButton();
			botonCuadrado.setMnemonic(KeyEvent.VK_UNDEFINED);
			botonCuadrado.setText("Cuadrados");
			botonCuadrado.setName("Cuadrado");
			botonCuadrado.addMouseListener(oyeBotFig);
		}
		return botonCuadrado;
	}

	/**
	 * This method initializes botonCirculo
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBotonCirculo() {
		if (botonCirculo == null) {
			botonCirculo = new JButton();
			botonCirculo.setText("Circulos");
			botonCirculo.setName("Circulo");
			botonCirculo.addMouseListener(oyeBotFig);
		}
		return botonCirculo;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setForeground(Color.blue);
			jTextField.setBounds(new Rectangle(295, 115, 99, 20));

			jTextField.setText("Nicolas Armando");
		}
		return jTextField;
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			oyentesDibujar = new OyentesDibujar(figuras,nombreUltimaFigura, getJPanel(),AccAct);
			
			oyentesMover = new OyentesMover(figuras, getJPanel(),AccAct);
			oyeBotFig = new OyenteBotonesFiguras(oyentesDibujar);
			oyeBotAcc = new OyenteBotonesAcciones(AccAct);
			oyentesDibujarMovimiento = oyentesDibujar.new OyenteDibujarMovimiento();
			oyentesMoverMovimiento = oyentesMover.new OyenteMoverMovimiento();
			jContentPane.add(getJPanel(), BorderLayout.CENTER);
			jContentPane.add(getOpcionesDibujo(), BorderLayout.SOUTH);
			jContentPane.add(getPanelOpciones(), BorderLayout.NORTH);
			jContentPane.add(getCantidadHojas(), BorderLayout.WEST);
			jContentPane.add(getPropiedadesFiguras(), BorderLayout.EAST);
			getJPanel().addMouseMotionListener(oyentesDibujarMovimiento);
			getJPanel().addMouseMotionListener(oyentesMoverMovimiento);
			getJPanel().addMouseListener(oyentesDibujar.new OyenteDibujarClicked());
			getJPanel().addMouseListener(oyentesMover.new OyenteMoverClicked());

			// getJPanel().addMouseMotionListener( new MouseMotionAdapter(){
			// public void mouseDragged(MouseEvent e) {
			// System.out.println("nico");
			// }
			// public void mouseMoved(MouseEvent e) {
			// System.out.println(e.getPoint());
			// }
			// });
			// lienzo1.addMouseMotionListener(uno);
			// lienzo1.addMouseListener(prueba.new OyenteDibujarDos());
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanPersonal getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanPersonal(figuras);
			jPanel.setLayout(null);
			jPanel.setBackground(Color.WHITE);
			jPanel.add(getJTextField(), null);

		}
		return jPanel;
	}

	/**
	 * This method initializes botonEscritura
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBotonEscritura() {
		if (botonEscritura == null) {
			botonEscritura = new JButton();
			botonEscritura.setText("Escritura");
			botonEscritura.setName("Escritura");
			botonEscritura.addMouseListener(oyeBotFig);

		}
		return botonEscritura;
	}

	/**
	 * This method initializes menuPrincipal
	 * 
	 * @return javax.swing.JMenuBar
	 */
	private JMenuBar getMenuPrincipal() {
		if (menuPrincipal == null) {
			menuPrincipal = new JMenuBar();
			menuPrincipal.add(getInicio());
			menuPrincipal.add(getEdicion());
			menuPrincipal.add(getOpciones());
			menuPrincipal.add(getAyuda());
		}
		return menuPrincipal;
	}

	/**
	 * This method initializes inicio
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getInicio() {
		if (inicio == null) {
			inicio = new JMenu();
			inicio.setText("Inicio");
			inicio.add(getAbrir());
			inicio.add(getGuardar());
			inicio.add(getGuardarComo());
			inicio.add(getSalir());
		}
		return inicio;
	}

	/**
	 * This method initializes edicion
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getEdicion() {
		if (edicion == null) {
			edicion = new JMenu();
			edicion.setText("Edicion");
			edicion.add(getCopiar());
			edicion.add(getPegar());
		}
		return edicion;
	}

	/**
	 * This method initializes opciones
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getOpciones() {
		if (opciones == null) {
			opciones = new JMenu();
			opciones.setText("Opciones");
		}
		return opciones;
	}

	/**
	 * This method initializes ayuda
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getAyuda() {
		if (ayuda == null) {
			ayuda = new JMenu();
			ayuda.setText("Ayuda");
			ayuda.add(getAcercaD());
		}
		return ayuda;
	}

	/**
	 * This method initializes opcionesFiguras
	 * 
	 * @return javax.swing.JToolBar
	 */
	private JToolBar getOpcionesFiguras() {
		if (opcionesFiguras == null) {
			opcionesFiguras = new JToolBar();
			opcionesFiguras.add(getBotonCirculo());
			opcionesFiguras.add(getBotonCuadrado());
			opcionesFiguras.add(getBotonEscritura());
			opcionesFiguras.add(getBotonImagen());
		}
		return opcionesFiguras;
	}

	/**
	 * This method initializes panelOpciones
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getPanelOpciones() {
		if (panelOpciones == null) {
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(1);
			gridLayout.setColumns(5);
			panelOpciones = new JPanel();
			panelOpciones.setLayout(gridLayout);
			panelOpciones.add(getOpcionesFiguras(), null);
			panelOpciones.add(getOpcionesMouse(), null);
		}
		return panelOpciones;
	}

	/**
	 * This method initializes OpcionesMouse
	 * 
	 * @return javax.swing.JToolBar
	 */
	private JToolBar getOpcionesMouse() {
		if (OpcionesMouse == null) {
			OpcionesMouse = new JToolBar();
			OpcionesMouse.add(getBotonCrear());
			OpcionesMouse.add(getBotonMover());
			OpcionesMouse.add(getBotonModificar());
		}
		return OpcionesMouse;
	}

	/**
	 * This method initializes acercaD
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getAcercaD() {
		if (acercaD == null) {
			acercaD = new JMenuItem();
			acercaD.setText("Acerca De...");
		}
		return acercaD;
	}

	/**
	 * This method initializes guardar
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getGuardar() {
		if (guardar == null) {
			guardar = new JMenuItem();
			guardar.setText("Guardar");
		}
		return guardar;
	}

	/**
	 * This method initializes guardarComo
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getGuardarComo() {
		if (guardarComo == null) {
			guardarComo = new JMenuItem();
			guardarComo.setText("Guardar Como");
		}
		return guardarComo;
	}

	/**
	 * This method initializes abrir
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getAbrir() {
		if (abrir == null) {
			abrir = new JMenuItem();
			abrir.setText("Abrir");
		}
		return abrir;
	}

	/**
	 * This method initializes salir
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getSalir() {
		if (salir == null) {
			salir = new JMenuItem();
			salir.setText("Salir");
		}
		return salir;
	}

	/**
	 * This method initializes cantidadHojas
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getCantidadHojas() {
		if (cantidadHojas == null) {
			cantidadHojas = new JPanel();
			cantidadHojas.setLayout(new GridBagLayout());
		}
		return cantidadHojas;
	}

	/**
	 * This method initializes propiedadesFiguras
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getPropiedadesFiguras() {
		if (propiedadesFiguras == null) {
			propiedadesFiguras = new JPanel();
			propiedadesFiguras.setLayout(new GridBagLayout());
		}
		return propiedadesFiguras;
	}

	/**
	 * This method initializes copiar
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getCopiar() {
		if (copiar == null) {
			copiar = new JMenuItem();
			copiar.setText("Copiar");
		}
		return copiar;
	}

	/**
	 * This method initializes pegar
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getPegar() {
		if (pegar == null) {
			pegar = new JMenuItem();
			pegar.setText("Pegar");
		}
		return pegar;
	}

	/**
	 * This method initializes botonCrear	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBotonCrear() {
		if (botonCrear == null) {
			botonCrear = new JButton();
			botonCrear.setText("Mover");
			botonCrear.setName("Mover");
			botonCrear.addMouseListener(oyeBotAcc);
		}
		return botonCrear;
	}

	/**
	 * This method initializes botonMover	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBotonMover() {
		if (botonMover == null) {
			botonMover = new JButton();
			botonMover.setText("Crear");
			botonMover.setName("Crear");
			botonMover.addMouseListener(oyeBotAcc);
		}
		return botonMover;
	}

	/**
	 * This method initializes BotonModificar	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBotonModificar() {
		if (botonModificar == null) {
			botonModificar = new JButton();
			botonModificar.setText("Modificar");
			botonModificar.setName("Modificar");
			botonModificar.addMouseListener(oyeBotAcc);
		}
		return botonModificar;
	}

	/**
	 * This method initializes botonPdf	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBotonPdf() {
		if (botonPdf == null) {
			botonPdf = new JButton();
			botonPdf.setText("Crear PDF");
		}
		return botonPdf;
	}

	/**
	 * This method initializes botonImagen	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBotonImagen() {
		if (botonImagen == null) {
			botonImagen = new JButton();
			botonImagen.setText("Imagenes");
			botonImagen.setName("Imagenes");
			botonImagen.addMouseListener(oyeBotFig);
		}
		return botonImagen;
	}
} // @jve:decl-index=0:visual-constraint="10,10"
